import _extends from "@babel/runtime/helpers/extends";
Component({
  data: {
    supportNative: !!my._createCanvas
  },
  props: {
    style: '',
    width: 100,
    height: 100,
    forceMini: false,
    pixelRatio: 1,
    onTouchEvent: function onTouchEvent() {},
    onInit: function onInit() {},
    onError: function onError() {}
  },
  didMount: function didMount() {
    if (!this.data.supportNative || this.props.forceMini) {
      this.onCanvasReady();
    }
  },
  methods: {
    onCanvasReady: function onCanvasReady() {
      var _this = this;

      my.createSelectorQuery().select('#canvas').boundingClientRect().exec(function (ret) {
        if (ret && ret[0]) {
          _this.rect = ret[0];
        } else {
          _this.rect = {
            bottom: 0,
            height: 0,
            left: 0,
            right: 0,
            top: 0,
            width: 0
          };
          _this.props.onError && _this.props.onError(ret);
        }

        if (_this.data.supportNative && !_this.props.forceMini) {
          console.log('native support');

          my._createCanvas({
            id: 'canvas',
            success: function success(canvas) {
              _this.ctx = canvas.getContext('2d');

              _this.ctx.scale(_this.props.pixelRatio, _this.props.pixelRatio);

              _this.props.onInit(_this.ctx, ret[0], canvas, 'mini-native');
            }
          });
        } else {
          console.log('web support');
          _this.ctx = my.createCanvasContext('canvas');

          _this.ctx.scale(_this.props.pixelRatio, _this.props.pixelRatio);

          _this.props.onInit(_this.ctx, ret[0], null, 'mini');
        }
      });
    },
    ontouch: function ontouch(e) {
      var _this2 = this;

      var target = e.target;

      var ev = _extends({}, e, {
        changedTouches: [],
        touches: []
      });

      e.touches.forEach(function (touchEvent) {
        ev.touches.push(modifyEvent(touchEvent, target, _this2.rect));
      });
      e.changedTouches.forEach(function (touchEvent) {
        // 真实的x的位置为client的位置 + rect的位置 +
        ev.changedTouches.push(modifyEvent(touchEvent, target, _this2.rect));
      });
      this.props.onTouchEvent(ev);
    }
  }
});

function modifyEvent(touchEvent, target, rect) {
  var x = touchEvent.pageX - rect.left; // target.offsetLeft;

  var y = touchEvent.pageY - rect.top; // target.offsetTop;

  return {
    x: x,
    y: y,
    identifier: touchEvent.identifier,
    clientX: x,
    clientY: y,
    pageX: x,
    pageY: y
  };
}